#include <amxmodx>
#include <colorchat>
#include <amxmisc>
#include <cstrike>
#include <fun>

#define PLUGIN "Moving Server"
#define VERSION "1.0"
#define AUTHOR "M@E$tro"

#define MOTD_FLAG_ARG 1
#define MOTD_FLAG_END 1

new bool:g_bSawMotd[33];
new g_HudColor;
new g_HudPos;

public plugin_init()
{
	    register_plugin(PLUGIN, VERSION, AUTHOR);
	    register_dictionary("moving_server.txt");
	
	    g_HudColor = register_cvar("moving_server_rgb", "255 255 255");
            g_HudPos = register_cvar("moving_server_post", "-1.0 0.15");
 
            register_message(get_user_msgid("ShowMenu"), "message_ShowMenu");
            register_message(get_user_msgid("VGUIMenu"), "message_ShowMenu");
	    register_message(get_user_msgid("MOTD"), "message_MOTD");
	
	    set_task(3.0, "ResetHUD");
	
	    set_task(1.0, "Screen", _, _, _, "b");

	    new configsDir[64];
	    get_configsdir(configsDir, 63)
	    server_cmd("exec %s/moving_server.cfg", configsDir)
}

public message_ShowMenu()
{
return PLUGIN_HANDLED
}

public Screen()
{
	for(new id=1;id<get_maxplayers();id++)
	{
		if(is_user_connected(id))
		{
			message_begin(MSG_ONE_UNRELIABLE, 98, _, id) 
			write_short(1<<0)
			write_short(1<<0)	// Hold time
			write_short(1<<2)
			write_byte(0)		// Red
			write_byte(0)		// Green
			write_byte(0)		// Blue
			write_byte(255)		// Alpha
			message_end()
		}
	}
}

public ResetHUD(id)
{
	set_task(3.0, "connect", id, _, _, "b")
}

public connect(id)
{
	static temp[3][10], color[3], Float:pos[2], i, text[21];
	
	get_pcvar_string(g_HudColor, text, 20)
	parse(text, temp[0], 3, temp[1], 3, temp[2], 3)
	for(i = 0; i < 3; i++) color[i] = str_to_num(temp[i])
	
	get_pcvar_string(g_HudPos, text, 20)
	parse(text, temp[0], 9, temp[1], 9)
	for(i = 0; i < 2; i++) pos[i] = floatstr(temp[i])

        set_hudmessage(color[0], color[1], color[2], pos[0], pos[1], 0, 0.0, 1.0, _, _, -1);
        show_hudmessage(id, "%L", id, "MOVING_SERVER_HUD");
        
        ColorChat(id, BLUE, "%L %L", id, "MOVING_SERVER_TAG", id, "MOVING_SERVER_CHAT");
}

public client_connect(id)
{
    g_bSawMotd[id] = false;
}

public message_MOTD(msgid, dest, id)
{
    if(!g_bSawMotd[id])
    {
        if(get_msg_arg_int(MOTD_FLAG_ARG) == MOTD_FLAG_END)
        {
            g_bSawMotd[id] = true;
        }
        return PLUGIN_HANDLED;
    }
    return PLUGIN_CONTINUE;
}